# decrunching library copied from Extended Module Player (XMP). Modified for
# uade.

CC      = gcc
CFLAGS  = -c -g -O2 -Wall -Wno-implicit-int -finline-functions -DHAVE_CONFIG_H {ARCHFLAGS}
OBJS	= decrunch_nl.o depack_nl.o unsqsh_nl.o crc32_nl.o mmcmp_nl.o sc68_nl.o easo_nl.o
LOBJS	= decrunch.lo depack.lo unsqsh.lo crc32.lo mmcmp.lo sc68.lo easo.lo

libdecr.a:	$(OBJS)
	ar r libdecr.a $(OBJS)
	ranlib libdecr.a

lobjects:	$(LOBJS)

decrunch_nl.o:	decrunch.c decrunch.h
	$(CC) $(CFLAGS) decrunch.c -o decrunch_nl.o

depack_nl.o:	depack.c decrunch.h
	$(CC) $(CFLAGS) depack.c -o depack_nl.o

unsqsh_nl.o:	unsqsh.c decrunch.h
	$(CC) $(CFLAGS) unsqsh.c -o unsqsh_nl.o

crc32_nl.o:	crc32.c decrunch.h
	$(CC) $(CFLAGS) crc32.c -o crc32_nl.o

mmcmp_nl.o:	mmcmp.c decrunch.h
	$(CC) $(CFLAGS) mmcmp.c -o mmcmp_nl.o

sc68_nl.o:	sc68.c decrunch.h
	$(CC) $(CFLAGS) sc68.c -o sc68_nl.o

easo_nl.o:	easo.c decrunch.h
	$(CC) $(CFLAGS) easo.c -o easo_nl.o

decrunch.lo:	decrunch.c decrunch.h
	libtool --mode=compile $(CC) $(CFLAGS) decrunch.c

depack.lo:	depack.c decrunch.h
	libtool --mode=compile $(CC) $(CFLAGS) depack.c

unsqsh.lo:	unsqsh.c decrunch.h
	libtool --mode=compile $(CC) $(CFLAGS) unsqsh.c

crc32.lo:	crc32.c decrunch.h
	libtool --mode=compile $(CC) $(CFLAGS) crc32.c

mmcmp.lo:	mmcmp.c decrunch.h
	libtool --mode=compile $(CC) $(CFLAGS) mmcmp.c

sc68.lo:	sc68.c decrunch.h
	libtool --mode=compile $(CC) $(CFLAGS) sc68.c

easo.lo:	easo.c decrunch.h
	libtool --mode=compile $(CC) $(CFLAGS) easo.c

clean:	
	rm -f *.o *.a *.lo core errlist depend
