 /* 
  * UAE - The Un*x Amiga Emulator
  * 
  * Support for Linux/USS sound
  * 
  * Copyright 1997 Bernd Schmidt
  */

#include <unistd.h>
#include <errno.h>
#include "uade.h"
#include "uade-os.h"
#include "effects.h"

extern int sound_fd;
extern uae_u16 sndbuffer[];
extern uae_u16 *sndbufpt;
extern int sndbufsize;
extern void finish_sound_buffer (void);

static __inline__ void check_sound_buffers (void) {

  if ((char *)sndbufpt - (char *)sndbuffer >= sndbufsize) {

    if ((char *)sndbufpt - (char *)sndbuffer > sndbufsize) {
      fprintf(stderr, "uade: A bug in sound buffer writing. Report this!\n");
    }

    if (uade_do_panning) {
      int samples = (((char *) sndbufpt) - ((char *) sndbuffer)) / 4;
      uade_effect_pan((short *) sndbuffer, samples, uade_pan_value);
    }

    if (uade_remote_slave) {
      uade_remote->write((void *) sndbuffer, sndbufsize);

    } else {
      uade_test_sound_block((void *) sndbuffer, sndbufsize);

      if (uade_swap_output_bytes)
	uade_swap_buffer_bytes(sndbuffer, sndbufsize);

      if (uade_usingoutpipe) {
	uade_write_to_outpipe(sndbuffer, sndbufsize);

      } else {
	finish_sound_buffer();
      }
    }
    sndbufpt = sndbuffer;
  }
}

#define PUT_SOUND_BYTE(b) do { *(uae_u8 *)sndbufpt = b; sndbufpt = (uae_u16 *)(((uae_u8 *)sndbufpt) + 1); } while (0)
#define PUT_SOUND_WORD(b) do { *(uae_u16 *)sndbufpt = b; sndbufpt = (uae_u16 *)(((uae_u8 *)sndbufpt) + 2); } while (0)
#define PUT_SOUND_BYTE_LEFT(b) PUT_SOUND_BYTE(b)
#define PUT_SOUND_WORD_LEFT(b) PUT_SOUND_WORD(b)
#define PUT_SOUND_BYTE_RIGHT(b) PUT_SOUND_BYTE(b)
#define PUT_SOUND_WORD_RIGHT(b) PUT_SOUND_WORD(b)
#define SOUND16_BASE_VAL 0
#define SOUND8_BASE_VAL 128

#define DEFAULT_SOUND_MAXB 8192
#define DEFAULT_SOUND_MINB 8192
#define DEFAULT_SOUND_BITS 16
#define DEFAULT_SOUND_FREQ 44100
#define HAVE_STEREO_SUPPORT
